﻿Copyright (c) (2015) Fluke Corporation                      MET/CAL Procedure
=============================================================================
INSTRUMENT:            Sub Meterman TMD90 Get Reading RS-232
INSTRUMENT:            Sub Meterman TMD90 Read Response RS-232
DATE:                  2016-01-06 12:26:45
AUTHOR:                Fluke
REVISION:              $Revision: 2619 $
ADJUSTMENT THRESHOLD:  70%
NUMBER OF TESTS:       3
NUMBER OF LINES:       137
=============================================================================
#
#  Procedure Author(s):
#        VY
#
#  Model(s) Covered:
#        Amprobe TMD90A, Meterman TMD90, Wavetek Meterman TMD90
#
#  Source(s):
#        Meterman TMD90 User Manual, PN 2099366, Copyright Sep 2003 *
#
#  Additional Equipment Required:
#        None
#
#  This procedure is intended for use with MET/CAL® calibration software;
#  the terms and conditions set forth in your MET/CAL license apply to this
#  procedure.
#
#  Due to Fluke's policy of continuously updating our products, this procedure
#  may contain minor differences in methods used and/or specifications to
#  those found in the manual or other documentation. While every effort has
#  been made to ensure that this procedure is accurate, Fluke cannot be held
#  responsible for the consequences of error or omissions found within this
#  procedure.
#
#  The copyright in this procedure is owned by Fluke Corporation.
#
#  The TMD90 serial response is of the basic form:
#
#    t<reading><unit>:t<reading><unit><CR><LF>
#
#  The length of the response varies from 18 to 21 bytes for the positive
#  or negative reading.
#
#  Examples:
#
#    Units      T1         T2      TMD90 Response String
#    -----   --------   --------   ----------------------
#     °C     No input   No input   t____C:t____C<CR><LF>
#     °F     No input   No input   t____F:t____F<CR><LF>
#     °C     0°         No input   t0000.0C:t____C<CR><LF>
#     °C     No input   -190.1°    t____C:t-0.190.1C<CR><LF>
#     °F     1199.9°    -0.1°      t1199.9F:t-0000.1F<CR><LF>
#
#  Calling procedure must contain the following line to set the proper
#  serial port settings.
#
#    1.001  PORT         [P2400,N,8,1,N]
#
#    MEM    reading
#
 STEP    FSC    RANGE NOMINAL        TOLERANCE     MOD1        MOD2  3  4 CON

  1.001  JMPL         GET_READING                  PSUBI("Get Reading")
  1.002  JMPL         READ_RESPONSE                PSUBI("Read Response")
  1.003  DISP         Subprocedure not found!
  1.004  END

  1.005  EVAL   Increment test number

# =====  Sub Meterman TMD90 Get Reading RS-232  =============================

  2.001  LABEL        GET_READING
# Get units and input number, and set the reading flag to false.
  2.002  MATH         Reading = 0

  2.003  DO
  2.004  CALL         Sub Meterman TMD90 Read Response RS-232

# Determine whether desired units are selected.
  2.005  WHILE        FIND(MEM2, @Units, 1) == 0
  2.006  DISP         Press °C °F key momentarily to select °[V @Units].
  2.007  WAIT         [D1500]
  2.008  CALL         Sub Meterman TMD90 Read Response RS-232
  2.009  ENDW

# Extract the T1 or T2 subfield from the
  2.010  MATH         MEM2 = FLD(MEM2, @Input, ":")

  2.011  WHILE        FIND(MEM2, "_", 1)
  2.012  DISP         T[V @Input] is open!
  2.012  DISP
  2.012  DISP         Verify connection to T[V @Input] input on the left.
  2.013  CALL         Sub Meterman TMD90 Read Response RS-232
  2.014  MATH         MEM2 = FLD(MEM2, @Input, ":")
  2.015  ENDW

# Convert the string to a number starting at the second character.
# This skips the leading "t".  Convert up to 6 characters.  The numeric
# portion of the string is 6 or 7 characters depending upon whether the
# reading is negative or positive.  Finally set the reading flag to true.
  2.016  MATH         MEM = SUB(MEM2, 2, 7); Reading = 1
  2.017  UNTIL        Reading

  2.018  END

  2.019  EVAL   Increment test number

# =====  Sub Meterman TMD90 Read Response RS-232  ===========================

  3.001  LABEL        READ_RESPONSE
# Intialize timeout counter.
  3.002  MATH         Count = 0

  3.003  DO
# 1. Clear input buffer.
# 2. Read first response and throwaway.
  3.004  PORT         [CLR][I!]

# Read response and store in MEM2.  Exit loop when the response is not
# the empty string or more than 10 attempts have been made.
  3.005  DO
  3.006  PORT         [I$]
  3.007  MATH         Count = Count + 1
  3.008  UNTIL        NOT(ZCMP(MEM2, "")) || (Count > 10)

  3.009  IF           Count > 10
  3.010  MATH         MEM2 = INI("startup", "port")
  3.011  DISP         Cannot obtain UUT RS-232 output.
  3.011  DISP
  3.011  DISP         Verify that UUT is properly connected to [MEM2]
  3.011  DISP         using TM-SW SERIAL CABLE.
  3.012  ENDIF

  3.013  UNTIL        NOT(ZCMP(MEM2, ""))

  3.014  END
